# frozen_string_literal: true

<% generation_message = '# This is a stub, used for indexing. The method is dynamically generated' %>
<% modules = library.to_s.split('::') %>
<% root = ('  ' * modules.size) %>
<% modules.each_with_index do |mod, indent| %>
<%= ('  ' * indent) %><%= "module #{mod}\n" %>
<% end %>
<% library.public_elements.each do |element| %>

<% if Chemlab::Element::CLICKABLES.include?(element[:type]) %>
<%= root %># @note Defined as +<%= "#{element[:type]} :#{element[:name]}" %>+
<%= root %># Clicks +<%= element[:name] %>+
<%= root %>def <%= element[:name] %>

<%= root %>  <%= generation_message %>.
<%= root %>end

<% else %>
<%= root %># @note Defined as +<%= "#{element[:type]} :#{element[:name]}" %>+
<%= root %># @return [String] The text content or value of +<%= element[:name] %>+
<%= root %>def <%= element[:name] %>

<%= root %>  <%= generation_message %>.
<%= root %>end

<% end %>

<% if Chemlab::Element::INPUTS.include?(element[:type]) %>
<%= root %># Set the value of <%= element[:name] %>

<%= root %># @example
<%= root %>#   <%= library.to_s %>.perform do |<%= modules.last.underscore %>|
<%= root %>#     <%= modules.last.underscore %>.<%= element[:name] %> = 'value'
<%= root %>#   end
<%= root %># @param value [String] The value to set.
<%= root %>def <%= element[:name] %>=(value)
<%= root %>  <%= generation_message %>.
<%= root %>end
<% end %>

<%= root %># @example
<%= root %>#   <%= library.to_s %>.perform do |<%= modules.last.underscore %>|
<%= root %>#     expect(<%= modules.last.underscore %>.<%= element[:name] %>_element).to exist
<%= root %>#   end
<%= root %># @return [Watir::<%= element[:type].to_s.classify %>] The raw +<%= element[:type].to_s.classify %>+ element
<%= root %>def <%= element[:name] %>_element
<%= root %>  <%= generation_message %>.
<%= root %>end

<%= root %># @example
<%= root %>#   <%= library.to_s %>.perform do |<%= modules.last.underscore %>|
<%= root %>#     expect(<%= modules.last.underscore %>).to be_<%= element[:name] %>

<%= root %>#   end
<%= root %># @return [Boolean] true if the +<%= element[:name] %>+ element is present on the page
<%= root %>def <%= element[:name] %>?
<%= root %>  <%= generation_message %>.
<%= root %>end

<% end %>
<% endings = [] %>
<% modules.size.times do |indent| %>
<% endings << "#{('  ' * indent)}end" %>
<% end %>
<%= endings.reverse.join("\n") %>
